/**
 * ThoughtSpot Public REST API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 2.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { FilterRules } from '../models/FilterRules';
import { GroupObject } from '../models/GroupObject';
import { ParameterValues } from '../models/ParameterValues';
import { TokenAccessScopeObject } from '../models/TokenAccessScopeObject';
import { HttpFile } from '../http/http';

export class GetCustomAccessTokenRequest {
    /**
    * Username of the ThoughtSpot user. The username is stored in the `name` attribute of the user object.
    */
    'username': string;
    /**
    * Password of the user account
    */
    'password'?: string;
    /**
    * The secret key string provided by the ThoughtSpot application server. ThoughtSpot generates a secret key when Trusted authentication is enabled.
    */
    'secret_key'?: string;
    /**
    * Token validity duration in seconds
    */
    'validity_time_in_sec'?: number;
    /**
    * ID of the Org context to log in to. If the Org ID is not specified and secret key is provided then user will be logged into the org corresponding to the secret key, and if secret key is not provided then user will be logged in to the Org context of their previous login session.
    */
    'org_identifier'?: string;
    /**
    * Indicates whether the specified attributes should be persisted or not.
    */
    'persist_option': GetCustomAccessTokenRequestPersistOptionEnum;
    /**
    * Filter rules.
    */
    'filter_rules'?: Array<FilterRules>;
    /**
    * Parameter values.
    */
    'parameter_values'?: Array<ParameterValues>;
    /**
    * Objects on which the filter rules and parameters values should be applied to
    */
    'objects'?: Array<TokenAccessScopeObject>;
    /**
    * (just-in-time (JIT) provisioning)Email address of the user. Specify this attribute when creating a new user.
    */
    'email'?: string;
    /**
    * (just-in-time (JIT) provisioning) Indicates display name of the user. Specify this attribute when creating a new user.
    */
    'display_name'?: string;
    /**
    * (just-in-time (JIT) provisioning) ID or name of the groups to which the newly created user belongs. Specify this attribute when creating a new user.
    */
    'groups'?: Array<GroupObject>;
    /**
    *    Creates a new user if the specified username does not exist in ThoughtSpot. To provision a user just-in-time (JIT), set this attribute to true.      Note: For JIT provisioning of a user, the secret_key is required.     Version: 10.5.0.cl or later 
    */
    'auto_create'?: boolean | null;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "username",
            "baseName": "username",
            "type": "string",
            "format": ""
        },
        {
            "name": "password",
            "baseName": "password",
            "type": "string",
            "format": ""
        },
        {
            "name": "secret_key",
            "baseName": "secret_key",
            "type": "string",
            "format": ""
        },
        {
            "name": "validity_time_in_sec",
            "baseName": "validity_time_in_sec",
            "type": "number",
            "format": "int32"
        },
        {
            "name": "org_identifier",
            "baseName": "org_identifier",
            "type": "string",
            "format": ""
        },
        {
            "name": "persist_option",
            "baseName": "persist_option",
            "type": "GetCustomAccessTokenRequestPersistOptionEnum",
            "format": ""
        },
        {
            "name": "filter_rules",
            "baseName": "filter_rules",
            "type": "Array<FilterRules>",
            "format": ""
        },
        {
            "name": "parameter_values",
            "baseName": "parameter_values",
            "type": "Array<ParameterValues>",
            "format": ""
        },
        {
            "name": "objects",
            "baseName": "objects",
            "type": "Array<TokenAccessScopeObject>",
            "format": ""
        },
        {
            "name": "email",
            "baseName": "email",
            "type": "string",
            "format": ""
        },
        {
            "name": "display_name",
            "baseName": "display_name",
            "type": "string",
            "format": ""
        },
        {
            "name": "groups",
            "baseName": "groups",
            "type": "Array<GroupObject>",
            "format": ""
        },
        {
            "name": "auto_create",
            "baseName": "auto_create",
            "type": "boolean",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return GetCustomAccessTokenRequest.attributeTypeMap;
    }

    public constructor() {
    }
}


export type GetCustomAccessTokenRequestPersistOptionEnum = "APPEND" | "NONE" | "REPLACE" | "RESET" ;

