/**
 * ThoughtSpot Public REST API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 2.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { GetFullAccessTokenRequestUserParameters } from '../models/GetFullAccessTokenRequestUserParameters';
import { HttpFile } from '../http/http';

export class GetFullAccessTokenRequest {
    /**
    * Username of the ThoughtSpot user. The username is stored in the `name` attribute of the user object.
    */
    'username': string;
    /**
    * Password of the user account
    */
    'password'?: string;
    /**
    * The secret key string provided by the ThoughtSpot application server. ThoughtSpot generates a secret key when Trusted authentication is enabled.
    */
    'secret_key'?: string;
    /**
    * Token validity duration in seconds
    */
    'validity_time_in_sec'?: number;
    /**
    * ID of the Org context to log in to. If the Org ID is not specified and secret key is provided then user will be logged into the org corresponding to the secret key, and if secret key is not provided then user will be logged in to the Org context of their previous login session.
    */
    'org_id'?: number;
    /**
    * Email address of the user. Specify this attribute when creating a new user (just-in-time (JIT) provisioning).
    */
    'email'?: string;
    /**
    * Indicates display name of the user. Use this parameter to provision a user just-in-time (JIT).
    */
    'display_name'?: string;
    /**
    *    Creates a new user if the specified username does not already exist in ThoughtSpot. To provision a user just-in-time (JIT), set this attribute to true.      Note: For JIT provisioning of a user, the secret_key is required. 
    */
    'auto_create'?: boolean | null;
    /**
    * ID or name of the groups to which the newly created user belongs. Use this parameter to provision a user just-in-time (JIT).
    */
    'group_identifiers'?: Array<string>;
    'user_parameters'?: GetFullAccessTokenRequestUserParameters;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "username",
            "baseName": "username",
            "type": "string",
            "format": ""
        },
        {
            "name": "password",
            "baseName": "password",
            "type": "string",
            "format": ""
        },
        {
            "name": "secret_key",
            "baseName": "secret_key",
            "type": "string",
            "format": ""
        },
        {
            "name": "validity_time_in_sec",
            "baseName": "validity_time_in_sec",
            "type": "number",
            "format": "int32"
        },
        {
            "name": "org_id",
            "baseName": "org_id",
            "type": "number",
            "format": "int32"
        },
        {
            "name": "email",
            "baseName": "email",
            "type": "string",
            "format": ""
        },
        {
            "name": "display_name",
            "baseName": "display_name",
            "type": "string",
            "format": ""
        },
        {
            "name": "auto_create",
            "baseName": "auto_create",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "group_identifiers",
            "baseName": "group_identifiers",
            "type": "Array<string>",
            "format": ""
        },
        {
            "name": "user_parameters",
            "baseName": "user_parameters",
            "type": "GetFullAccessTokenRequestUserParameters",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return GetFullAccessTokenRequest.attributeTypeMap;
    }

    public constructor() {
    }
}

