/**
 * ThoughtSpot Public REST API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 2.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { FavoriteMetadataInput } from '../models/FavoriteMetadataInput';
import { HttpFile } from '../http/http';

export class ImportUser {
    /**
    * Unique ID or name of the user.
    */
    'user_identifier': string;
    /**
    * Display name of the user.
    */
    'display_name': string;
    /**
    * Password of the user.
    */
    'password'?: string | null;
    /**
    * Type of the user account.
    */
    'account_type'?: ImportUserAccountTypeEnum | null;
    /**
    * Status of the user account.
    */
    'account_status'?: ImportUserAccountStatusEnum | null;
    /**
    * Email address of the user.
    */
    'email'?: string | null;
    /**
    * ID or name of the Orgs to which the user belongs.
    */
    'org_identifiers'?: Array<string> | null;
    /**
    * ID or name of the groups to which the user belongs.
    */
    'group_identifiers'?: Array<string> | null;
    /**
    * Visibility of the users. The SHARABLE property makes a user visible to other users and group, who can share objects with the user.
    */
    'visibility'?: ImportUserVisibilityEnum | null;
    /**
    * Notify user when other users or groups share metadata objects
    */
    'notify_on_share'?: boolean | null;
    /**
    * Show or hide the new user onboarding walkthroughs
    */
    'show_onboarding_experience'?: boolean | null;
    /**
    * Revisit the new user onboarding walkthroughs
    */
    'onboarding_experience_completed'?: boolean | null;
    /**
    * Unique ID or name of the default Liveboard assigned to the user.
    */
    'home_liveboard_identifier'?: string | null;
    /**
    * Metadata objects to add to the user\'s favorites list.
    */
    'favorite_metadata'?: Array<FavoriteMetadataInput> | null;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "user_identifier",
            "baseName": "user_identifier",
            "type": "string",
            "format": ""
        },
        {
            "name": "display_name",
            "baseName": "display_name",
            "type": "string",
            "format": ""
        },
        {
            "name": "password",
            "baseName": "password",
            "type": "string",
            "format": ""
        },
        {
            "name": "account_type",
            "baseName": "account_type",
            "type": "ImportUserAccountTypeEnum",
            "format": ""
        },
        {
            "name": "account_status",
            "baseName": "account_status",
            "type": "ImportUserAccountStatusEnum",
            "format": ""
        },
        {
            "name": "email",
            "baseName": "email",
            "type": "string",
            "format": ""
        },
        {
            "name": "org_identifiers",
            "baseName": "org_identifiers",
            "type": "Array<string>",
            "format": ""
        },
        {
            "name": "group_identifiers",
            "baseName": "group_identifiers",
            "type": "Array<string>",
            "format": ""
        },
        {
            "name": "visibility",
            "baseName": "visibility",
            "type": "ImportUserVisibilityEnum",
            "format": ""
        },
        {
            "name": "notify_on_share",
            "baseName": "notify_on_share",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "show_onboarding_experience",
            "baseName": "show_onboarding_experience",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "onboarding_experience_completed",
            "baseName": "onboarding_experience_completed",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "home_liveboard_identifier",
            "baseName": "home_liveboard_identifier",
            "type": "string",
            "format": ""
        },
        {
            "name": "favorite_metadata",
            "baseName": "favorite_metadata",
            "type": "Array<FavoriteMetadataInput>",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return ImportUser.attributeTypeMap;
    }

    public constructor() {
    }
}


export type ImportUserAccountTypeEnum = "LOCAL_USER" | "LDAP_USER" | "SAML_USER" | "OIDC_USER" | "REMOTE_USER" ;
export type ImportUserAccountStatusEnum = "ACTIVE" | "INACTIVE" | "EXPIRED" | "LOCKED" | "PENDING" | "SUSPENDED" ;
export type ImportUserVisibilityEnum = "SHARABLE" | "NON_SHARABLE" ;

